#!/usr/bin/perl


# ojo en distcheck salen errores diciendo que no puede escribir en dirac1.dat
# efectivamente este archivo es de solo lectura, ver que pasa
# igual pasa los tests, porque???? esto es lo unico que me preocupa de lo anmterior

use warnings;
use strict;

use Getopt::Long;
use Pod::Usage; 
use Cwd;
use Cwd 'abs_path';
use File::Spec;
# Ejecuta algún sceptre sobre el archivo $dir/${filesind}.d 
# y manda los resultados,
# junto con una copia de $filesind.d a un subdirectorio $modo/$filesind
# de un directorio $diroutput (usualmente sera un temporario).
# Compara los archivos resultantes de esa ejecucion con los resultados
# registrados.en $dir
# Cuales archivos resultantes comparar está asociado con el nombre $modo
# posibles valores de $modo:  dirac acdirac withoutdirac err1 err2
# los argumentos de direccion deben venir o 
# se transforman en seguida a dirctorios absolutos 

# El sceptre esta determinado por $SCEPTRE1, $sceptre2o ,$LIBSCEPTRE y $LIBAUX
# que son los primeros cuatro argumentos para este programa.

# Se necesita tambien el $SCEPTRE_DIRAC y el compilador fortran $FORTRAN que son
# quinto y sexto argumento; 
# los otros cuatro son: $modo, $dir, $filesind, $outputdir
#  Para un sceptre-inenco ya compilado, antes de la instalacion,
#        y a partir de trunk:
#    $SCEPTRE1:      src/phase1/sceptre1
#    $sceptre2o      src/phase2/sceptre2.o
#    $LIBSCEPTRE     src/phase2/libsceptre.a
#    $LIBSCEPTREAUX  src/auxpro/libsceptreaux.a
#    $SCEPTRE_DIRAC  src/auxpro/sceptre_dirac
#  Un sceptre ya instalado, por ejemplo en /usr/local queda determinado por:
#    $SCEPTRE1:      /usr/local/bin/sceptre1
#    $sceptre2o      /usr/local/lib/sceptre2.o
#    $LIBSCEPTRE     /usr/local/lib/libsceptre.a
#    $LIBSCEPTREAUX  /usr/local/lib/libsceptreaux.a
#    $SCEPTRE_DIRAC  /usr/local/bin/sceptre_dirac
 
# El programa retorna 0 si hay coincidencia y 1 si no la hay

$0 =~ m!/([^/]+)\s*$!;
my $progname = $1;
my %opt_hash;
our $version = "1.0";
GetOptions(\%opt_hash, 'help','version','debug') or pod2usage(3);
#print scalar @ARGV,"\n"; print "$ARGV[8]\n";

#exit 1 unless $ARGV[8] eq 'wreal'; # para hacer solo una prueba

help() if defined $opt_hash{help};
version() if defined $opt_hash{version};

my %extensions = ('dirac'=> ['.ls1','.ini','.ls2','.dat','.dirac']
            ,'acdirac' => ['.ls1','.ini','.acs','.ls2','.dirac']
            ,'withoutdirac'=>['.ls1','.ini','.ls2']
            ,'err1'=>['.ls1']
            ,'err2'=>['.ls1','.ini']);
my ($SCEPTRE1,$sceptre2o,$LIBSCEPTRE,$LIBSCEPTREAUX,$SCEPTRE_DIRAC,$FORTRAN
    ,$modo,$dir,$filesind,$diroutput) = @ARGV;

our $sceptre_dirac = $SCEPTRE_DIRAC;
my $pwd = getcwd();


system "cp $dir/$filesind.d $diroutput/ 2>/dev/null";


my $err = system 
  "$SCEPTRE1 -o $diroutput $diroutput/$filesind >/dev/null 2>/dev/null";
($err > 0 or not -s "$diroutput/$filesind.for")  and $opt_hash{debug} and print "fallo traducción\n"; 
if (-s "$diroutput/${filesind}.for") {
    system "sed 's/\\\$/\_/g' <$diroutput/${filesind}.for >$diroutput/${filesind}.f";  
    $err = system 
"$FORTRAN -o $diroutput/${filesind}_run $diroutput/${filesind}.f $LIBSCEPTRE $LIBSCEPTREAUX"
." >/dev/null 2>/dev/null"; 
    $err and $opt_hash{debug} and print "fallo compilación\n"; 
    if (not $err) {
        system "$diroutput/${filesind}_run >/dev/null 2>/dev/null";
        $err and $opt_hash{debug} and print "fallo ejecución";
    };
};

#system "echo dir $dir";
my @exten = @{$extensions{$modo}};
#print __LINE__," @exten\n";
-e "$filesind.sim" and push @exten,'.sim';
my($fm,$diff) = (' 'x5,'');
foreach my $ext (@exten) {
    my $refuno = extract("$dir/$filesind",$ext);
    my $refdos = extract("$dir/$filesind",$ext);
    #print __LINE__," $filesind $ext ",scalar @$refuno, ' '
    #       ,scalar @$refdos,"\n";
    if (@$refdos and @$refuno) {
        if (@$refdos != @$refuno) {
            $diff .= $fm . 'x';
        } else {
            my $diffe = '';
            while (@{$refuno}) {
                my $uno = shift @{$refuno};
                my $dos = shift @{$refdos};
                if ($uno ne $dos) {
                    if ($opt_hash{debug}) {
                        print "............... $modo $filesind$ext\n";
                        print "$uno\n";
                        print "$dos\n";
                    }; 
                    $diff .= $fm . 'x';
                    $diffe = 1;
                    last;
                };
            };
            $diffe or $diff .= $fm . '='; 
        };  
    } elsif (@$refuno) {
	$diff .= $fm . '1';
    } elsif (@$refdos) {
	$diff .= $fm . '2';
    } else {
        $diff .= $fm . '0';
    };
};
my $passed = "passed"; 
if ($diff =~ /[x1]/) {
    $passed ="no passed";
};
if ($opt_hash{debug}) {
    print " ";
    map(do{printf  "%6s", $_},@exten);print "\n";
    print $diff,"   $passed ${modo}_$filesind\n";
};


$passed eq 'passed' and exit 0 or exit 1;
#----------------------------------------------------------------------------
sub extract{
    my ($filesind,$ext) = @_;
    my @lista; my $reflista = \@lista;
    if ($ext eq '.dirac') {
        if (-e "$filesind$ext") {
            system "cp $filesind.dirac dirac1.dat";
            system "$sceptre_dirac >/dev/null 2>/dev/null";
            @lista = `cat dirac2.dat`; chomp @lista; 
        };      
    } else {
        @lista = `cat $filesind$ext`; chomp @lista;
        if ($ext =~ /^\.ls[12]/) {
            limpiar_fechas($reflista);
            DtoE($reflista);
            NANINF($reflista);
        } elsif ($ext eq '.dat') {
            tapar_tiempo($reflista);
            DtoE($reflista);
            NANINF($reflista);
        } elsif ($ext eq '.sim') {
            DtoE($reflista);
            NANINF($reflista);
        } else {
            DtoE($reflista);
            NANINF($reflista);
        }; 
    };
    return $reflista;
}

#----------------------------------------------------------------------------
sub NANINF{
  # se transforma al modo g77
 my $reflista = $_[0];
  map (do {while (/NAN/) {s/NAN/NaN/};
           while (/INF/) {
#               print "$_\n";
               s/\-INF/\-Infinity/;
               s/ INF/\ +Infinity/;
#               print "$_\n";
           };
       },@$reflista);
  return;
}
# ----------------------------------------------------------------------------
sub DtoE{
#  print "Aqui DtoE\n";
#  print "Aqui DtoE\n";
  my $reflista = $_[0];
  map (do {s/\s+/ /g;
           s/([\.\d]+)D([\+\-]\d\d)/$1E$2/g;
           s/\-(0\.0+[DE]\+00)/ $1/g;  # signed zero
           while (s/(\s)\-(0\.0+)(\s)/$1 $2$3/){};
           s/(\s)\-(0\.0+)$/$1 $2/;
           s/^\-(0\.0+)(\s)/ $1 $2/;
           s/\s+$//;
       },@$reflista);
#  print 'scalar @lista ',scalar @$reflista,"\n";
  @$reflista = grep (/\S/,@$reflista);
#  print 'scalar @lista ',scalar @lista,"\n";
  return;
}
#----------------------------------------------------------------------------
sub limpiar_fechas{
# "limpia" fechas y cambia EXEC1 y sceptre1 por sc_EXEC1
  my $reflista = $_[0];
#  print "Aqui limpiar_fechas $arch $archs\n";
  my $ddd8 = 'd' x 8;
  my $ddd10 = 'd' x 10;
  my $blank14 = ' ' x 14;
  my $ccc36 = 'c'x 38;
  map (do {
            s/\d\d\d\d\d\d\/\d\d\d\d\d\d/$ddd10\/$ddd8/g;
            s/\d\d\.\d\d\.\d\d\d\d/$ddd10/g;
            s/\d\d\.\d\d\.\d\d/$ddd8/g;
            s/\d\d\:\d\d\:\d\d/$ddd8/g;
            s/Date compiled: /$blank14 /g;
            s/^(1S C E P T R E  release).*(WRNovender)/$1 $ccc36 $2/;
	    s/(SOLUTION \(CPU\).*:\s*)\S.*$/$1nnnnnnnn/;
            s/POS version .../POS version vvv/;
	    s/EXEC1/sce_EXEC1/g; s/sceptre1/sce_EXEC1/g;
       },@$reflista);
  @$reflista = grep ($_ !~ /LAST STEP SIZE/,@$reflista);
  return;
} 
#----------------------------------------------------------------------------
sub tapar_tiempo{
  my $reflista = $_[0];
# print "Aqui tapar_tiempo $arch $archs\n";
  my $t13 = 't' x 13;
  $reflista->[7] =~ s/^\s\S*\s\S*(\s\S*)(\s\S*)\s\S*/ $t13 $t13$1$1 $t13/;
  return;
}
#----------------------------------------------------------------------------
sub tratar_dirac{
#  print "Aqui tratar_dirac\n";
  my ($arch,$archs,$archsg,$archs7) = @_;
  system "rm dirac1.dat 2>/dev/null; cp $arch dirac1.dat";
  my $rcode = system "$sceptre_dirac 2>/dev/null";
  system "mv dirac2.dat $archs";
  $rcode = system "$sceptre_dirac 2>/dev/null";
  system "mv dirac2.dat $archsg";
  system "mv dirac2.dat $archs7";
  system "rm dirac1.dat";
 }
#----------------------------------------------------------------------------
sub help{
    pod2usage({-verbose => 3
           ,-exit => 0
	   ,-message => "   $progname $version
       es parte del conjunto de scripts de sceptre-inenco"
	   });
 }
# ----------------------------------------------------------------------------
sub version{
    print "\n      $progname  $version\n\n";
    exit 0;
} 
# ----------------------------------------------------------------------------
sub pod{
    my %hash = ('-message' => $_[0],'-verbose'=>2);
    pod2usage(\%hash);
    exit 1; 
}
# ----------------------------------------------------------------------------
__END__
=head1 NAME

sceptre_test.pl

=head1 SYNOPSIS

B<<sceptre_test.pl> [I<options>]  I<arguments>

options:

B<-help -version -norev -erase>

arguments:

I<mode> I<dir> I<filesind> I<SCEPTRE> I<diroutput>

=head1 OPTIONS/ARGUMENTS

=over 15

=item B<-h  --help>

give this help list

=item B<-v  --version>

print program version

=item B<norev>

does not controle goodness of arguments

=item B<erase>

remove created directory (with its files)

=item B<mode>

dirac|acdirac|withoutdirac|err1|err2

=item B<dir> 

directory where B<filesind>.d and 'good' results are found

=item B<filesind>

name of file for Sceptre, without extension .d

=item B<SCEPTRE>

Sceptre command to be tested on copy of B<filesind>.d

=item B<diroutput> 

directory where files .dif will be kept and where (may be temporary) directory
will be created

=back

=head1 DESCRIPTION

create, copy, run, compare
